if (!Pages.Abstract) throw "Requires: [Pages.Abstract]";

Pages.Contacts = new Class({
	
	Extends: Pages.Abstract,
	
	val: 10,
	
	options: {
		place: '^contact'
	},
	
	thisPage: function(place){
		this.initWidget();
	},
	
	initWidget: function()
	{
		var _ = this;
		
		$('ContactSubmit').addEvent('click', function(e){
			_.submitForm();
			return false;
		});
	},
	
	createURL: function()
	{
		var url = "/contact?";
		var urlStr = "";
		var table = $('Contacts-content').getElements('table')[0];
		
		table.getElements('tr').each(function(element){
			
			var qtyField = element.getElements('input[type=text]')[0];
			
			if(qtyField != null){
				var name = qtyField.get('name');
				var value = qtyField.get('value');
				var val = name + '=' + value;
				urlStr += urlStr.length == 0 ? urlStr + val : '&' + val;
			}
		});
		
		var textArea = table.getElements('textarea')[0];
		var name = textArea.get('name');
		var value = textArea.get('value');
		var val = name + '=' + value;
		urlStr += urlStr.length == 0 ? urlStr + val : '&' + val;
		
		
		if(urlStr.length > 0)
		{
			url += urlStr;
		}else
			url = "";
		
		return url;
	},
	
	isFormValid: function()
	{
		var isValid = true;
		var table = $('Contacts-content').getElements('table')[0];
		
		table.getElements('tr').each(function(element){
			var input = element.getElements('input[type=text]')[0];
			if(input != null && input.get('value') == ''){
				isValid = false;
			}
		});
		
		return isValid;
	},
	
	resetForm: function()
	{
		var table = $('Contacts-content').getElements('table')[0];
		
		table.getElements('tr').each(function(element){
			var input = element.getElements('input[type=text]')[0];
			if(input != null){
				input.set('value','');
			}
		});
		
		var textArea = table.getElements('textarea')[0];
		textArea.set('value','');
	},
	
	submitForm: function()
	{
		var _ = this;
		var URL = _.createURL();
		if(URL.length > 0)
		{
			$('Busy-top').fade('in');
			new Request.HTML({ url: URL,
				onComplete: function (responseTree, responseElements, responseHTML, responseJavaScript) {
					$('Busy-top').fade('out');
					_.resetForm();
				}
			}).send();
		}		
	}
});

Pages.contacts = new Pages.Contacts();
