if (!Website.Menu) throw "Requires: [Website.Menu]";
/**
 * Website.MainMenu
 * 
 * @package 	Website
 * @depends		Website
 */
Website.MainMenu = new Class({
	
	Extends: Website.Menu,
	
	options: {
		menuLinks: null
	},
	
	initialize: function(options)
	{
		this.setOptions(options);
		this.menu = Website.mainMenuItems;
	},
	
	getPagerLinks: function(urlBase)
	{
		var index = this.indexOfBase(urlBase);
		var count = this.menu.length;
		var prev = (count+index-1)%count;
		var next = (index+1)%count;
		
		$L.from('Website').debug(
				'Pagers: <<'+prev+'--'+index+'--'+next+'>>');
		
		return {
			prev: '/'+this.menu[prev].href,
			next: '/'+this.menu[next].href
		};
	},
	
	hoverStart: function()
	{
		this.options.menuLinks.each(function(element,i){
			
			var em = element.getElements('em')[0].setStyles({
				'opacity': 0,
				'visibility': 'visible'
			});
			
			var transEffect = new Fx.Morph(em, {
				duration: 500,
				transition: Fx.Transitions.Linear
			});
			
			element.addEvents({
				'mouseover':function(){
					transEffect.cancel();
					(function(){transEffect.start({opacity:1});}).delay(200);
				},
				'mouseout':function(){
					transEffect.cancel();
					transEffect.start({opacity:0});
				}
			});
		}.bind(this));
	}
	
});
