if (!Website) throw "Requires: [host page.Website]";
/**
 * Website.Nav
 * 
 * @package 	Website
 * @depends		Website
 */
Website.Nav = new Class({
	
	Implements: [Options],
	
	options: {
		nav: null,
		mainMenu: null,
		displayBase: null,
		displaySub: null
	},
	
	log: $L.from('Website.Nav'),
	
	initialize: function(options)
	{
		this.setOptions(options);
		
		window.addEvent('historychange', function(url){
			var code = this.getCode(url);
			this.log.debug('Animate caret: url['+url+'] code['+code+']');
			this.options.displayBase.animateCaret(code);
		}.bind(this));
	},
	
	getCode: function(url)
	{
		// Get the url base stripping _ and /
		var urlBase = Nav.instance().getPathBase(url);
		// Get code based on URL
		return this.options.mainMenu.getCodeOfBase(urlBase);
	},
	
	// Hijax
	load: function(request, container, mappedUrl, hijack)
	{
		// Get code based on URL
		var code = this.getCode(mappedUrl.href);
		
		this.log.debug('Load page: url['+mappedUrl.href+'] code['+code+']');
		
		var nav = this.options.nav;
		
		nav.ifNotBusy(function(){
			
			// Set nav to busy
			nav.setBusy(true);
			
			if (mappedUrl.level === 0 && !mappedUrl.levelDown)
			{
				// Do the swap and provide a callback for setting nav to unbusy
				this.options.displayBase.swapPage(request, container, mappedUrl, hijack, 
					code, new BusyTracker(function(){
						
						// This has already been done in Website.Nav but no harm in making sure.
						this.options.displayBase.animateCaret(code);
						
						// Set nav to unbusy
						nav.setBusy(false);
						
						window.fireEvent('basepageloaded', mappedUrl.href);
						window.fireEvent('pageloaded', mappedUrl.href);
					}.bind(this))
				);
			}
			else
			{
				// Do the swap and provide a callback for setting nav to unbusy
				this.options.displaySub.swapPage(request, container, mappedUrl, hijack, 
					code, new BusyTracker(function(){
						
						// Set nav to unbusy
						nav.setBusy(false);
						window.fireEvent('subpageloaded', mappedUrl.href);
						window.fireEvent('pageloaded', mappedUrl.href);
					})
				);
			}
			
		}.bind(this));
	}
		
});
