<?php defined('SYSPATH') or die('No direct script access.');

class Controller_Pages_Downloads extends Controller{

	//public $template = 'template/reports';
	//public $subtitle = 'Reports';
	
	public $rate = 1;

	public function action_prices()
	{
        $this->download_price_list();
	}
	
	public function action_voucher()
	{
		$id = $this->request->param('id');
		if(isset($id))
		{
			$file = APPPATH. '../../../vouchers/aquaventures-voucher_'.$id.'.pdf';
			$this->download_file($file, 'Aqua Ventures Voucher.pdf', FALSE);
		}
	}
	
	protected function createPriceListPDF()
	{	
		require_once(APPPATH.'vendor/tcpdf/config/lang/eng.php');
		$pdf = Pdf::factory('prices');
		
		// set default monospaced font
		$pdf->SetDefaultMonospacedFont(PDF_FONT_MONOSPACED);
		
		//set margins
		$pdf->SetMargins(PDF_MARGIN_LEFT, PDF_MARGIN_TOP, PDF_MARGIN_RIGHT);
		$pdf->SetHeaderMargin(PDF_MARGIN_HEADER);
		$pdf->SetFooterMargin(PDF_MARGIN_FOOTER);
		
		//set auto page breaks
		$pdf->SetAutoPageBreak(TRUE, PDF_MARGIN_BOTTOM);
		
		//set image scale factor
		$pdf->setImageScale(PDF_IMAGE_SCALE_RATIO);
		
		//set some language-dependent strings
		$pdf->setLanguageArray($l);

		// set font
		$pdf->SetFont('helvetica', '', 10);
		
		// add a page
		$pdf->AddPage();
		
		$html = $this->create_price_list_page();
		
		$pdf->writeHTML($html, true, false, true, false, '');
		
		//Close and output PDF document
		$pdf->Output('Aqua Ventures Rates.pdf', 'D');
		
	}
	
	protected function create_price_list_page()
	{
		$html = '';
		
		$curr = Kohana::$config->load('currency.default');
		$default_currency = $curr;
		$symbols = Kohana::$config->load('currency.symbols');
		$default_symbol = $symbols[$curr];
		
		if(isset($_GET['r-currency'])){
			$curr = $_GET['r-currency'];
		}
		
		if($curr == $default_currency){
			$curr =  Kohana::$config->load('currency.alternate_currency');
		}

		$price_currency = Kohana::$config->load('currency.price_currency');
		
		$messages = Kohana::$config->load('rates.messages');
		
		$curr_symbol = $symbols[$curr];
		
		$this->set_rate($curr);
		
		$diving_prices = $this->convert_prices(Kohana::$config->load('rates.diving_prices'));
		$diving_list = Kohana::$config->load('rates.diving_list');
		
		$diving_packages_prices = $this->convert_prices(Kohana::$config->load('rates.diving_packages_prices'));
		$diving_packages_list = Kohana::$config->load('rates.diving_packages_list');

		$padi_prices = $this->convert_prices(Kohana::$config->load('rates.padi_prices'));
		$padi_list = Kohana::$config->load('rates.padi_list');
		
		$bsac_prices = $this->convert_prices(Kohana::$config->load('rates.bsac_prices'));
		$bsac_list = Kohana::$config->load('rates.bsac_list');
		
		
		$html = '<div>
					<div>
				        <h2>Dives</h2>
				        <table>';
		
			            foreach ($diving_list as $item) {
			                if(!isset($item[0])){continue;}
					               $html .= "<tr>";
					               $html .= '<td width="45%">'.$item[1].'</td>';
					               $html .= '<td width="20%" style="color: #777;">'.$item[2].'</td>';
					               $html .= '<td width="15%" style="text-align: right">'.$default_symbol.$diving_prices[$item[0]][0].'</td>';
					               $html .= '<td width="20%" style="text-align: right; color: green;">'.$curr_symbol.number_format($diving_prices[$item[0]][1], 2, '.', ',').'</td></tr>';
            			}
            			
				        $html .='</table></div>';
						$html .='<div>';
				        $html .='<h2>Dive Packages</h2>';
				        $html .='<table>';
				        
			            foreach ($diving_packages_list as $item) {
			                if(!isset($item[0])){continue;}
					               $html .= "<tr>";
					               $html .='<td width="45%">'.$item[1].'</td>';
					               $html .= '<td width="20%" style="color: #777;">'.$item[2].'</td>';
					               $html .= '<td width="15%" style="text-align: right">'.$default_symbol.$diving_packages_prices[$item[0]][0].'</td>';
					               $html .= '<td width="20%" style="text-align: right; color: green;">'.$curr_symbol .number_format($diving_packages_prices[$item[0]][1], 2, '.', ',').'</td></tr>';
			            }
            			$html .='<tr>';
                		$html .='<td colspan="4">'.$messages['surcharge'].'</td>';
            			$html .='</tr>';
        				$html .='</table>';
						$html .='</div>';
	
						$html .='<div>';
						$html .='<h2>PADI Qualifications</h2>';
						$html .='<table>';
            
						foreach ($padi_list as $item) {
                			if(!isset($item[0])){continue;}
					               $html .= "<tr>";
					               $html .='<td width="45%">'.$item[1].'</td>';
					               $html .= '<td width="20%" style="color: #777;">'.$item[2].'</td>';
					               $html .= '<td width="15%" style="text-align: right">'.$default_symbol.$padi_prices[$item[0]][0].'</td>';
					               $html .= '<td width="20%" style="text-align: right; color: green;">'.$curr_symbol.number_format($padi_prices[$item[0]][1], 2, '.', ',').'</td></tr>';
						}
						
						$html .='</table>';
						$html .='</div>';
						$html .='<div>';
						$html .='<h2>BSAC Qualifications</h2>';
						$html .='<table>';
						
            			foreach ($bsac_list as $item) {
                			if(!isset($item[0])){continue;}
					               $html .= "<tr>";
					               $html .='<td width="45%">'.$item[1].'</td>';
					               $html .= '<td width="20%" style="color: #777;">'.$item[2].'</td>';
					               $html .= '<td width="15%" style="text-align: right">'.$default_symbol.$bsac_prices[$item[0]][0].'</td>';
					               $html .= '<td width="20%" style="text-align: right; color: green;">'.$curr_symbol.number_format($bsac_prices[$item[0]][1], 2, '.', ',').'</td></tr>';
						}
						
						$html .='<tr>';
						$html .='<td colspan="4">';
						$html .='BSAC Sports Diver, Dive Leader, Advanced Diver and Skill Development courses are available on request.';
						$html .='</td>';
						$html .='</tr>';
						$html .='</table>';
						$html .='</div>';
						$html .='<p>'.$messages['park_fees'].'</p>';
						$html .='<p style="color: green;">Aqua Ventures lists prices in US Dollars. For your convenience, we have listed the equivalent amounts in your currency. These estimates are subject to change.</p>';
						$html .='</div>';
		return $html;
	}
	
	protected function createVoucher()
	{
		require_once(APPPATH.'vendor/tcpdf/config/lang/eng.php');
		$pdf = Pdf::factory('voucher');
		
		// set default monospaced font
		$pdf->SetDefaultMonospacedFont(PDF_FONT_MONOSPACED);
		
		//set margins
		$pdf->SetMargins(PDF_MARGIN_LEFT, PDF_MARGIN_TOP, PDF_MARGIN_RIGHT);
		$pdf->SetHeaderMargin(PDF_MARGIN_HEADER);
		$pdf->SetFooterMargin(PDF_MARGIN_FOOTER);
		
		//set auto page breaks
		$pdf->SetAutoPageBreak(TRUE, PDF_MARGIN_BOTTOM);
		
		//set image scale factor
		$pdf->setImageScale(PDF_IMAGE_SCALE_RATIO);
		
		//set some language-dependent strings
		$pdf->setLanguageArray($l);

		// set font
		$pdf->SetFont('helvetica', '', 10);
		// add a page
		$pdf->AddPage();
		
		$y = $pdf->getY();
		$pdf->SetY($y + 20);
		
		$html = $this->get_voucher_html();
		$pdf->writeHTML($html, true, false, true, false, '');
		
		$pdf->AddPage();
		
		$y = $pdf->getY();
		$pdf->SetY($y + 20);
		
		$html = $this->get_voucher_html();

		$pdf->writeHTML($html, true, false, true, false, '');
		
		//Close and output PDF document
		$pdf->Output('Aqua Ventures Voucher.pdf', 'I');
	}
	
	protected function get_voucher_html()
	{
		
		$item = 'Scuba Dive';
		$token = '324443333';
		
		$user_details = array(
			'first_name' => 'Vincent',
			'last_name' => 'Tuwei',
			'email' => 'vintuwei@gmail.com',
			'phone' => '0702575698',
		);
		
		$legal_url = URL::base().'legal';
		
		$html = '<table style="margin-top: 100px;">
				<tr>
				<td>
						<h3 style="margin: 0px; padding: 0px;">Voucher</h3>
						<ul style="list-style-type: none;padding:0px;margin:0px;">
							<li>'.$item.'</li>
						</ul>
				</td>
				<td style="padding-left: 100px;">
					<table>
						<tr>
							<td style="border-bottom: 1px dashed black; line-height: 5px;">
								Code: <span>'.$token.'</span>
							</td>
						</tr>
						<tr>
							<td style="border-bottom: 1px dashed black; line-height: 5px;">
								Purchased by: <span>'.$user_details['first_name'].'</span> <span>'.$user_details['last_name'].'</span>
							</td>
						</tr>
						<tr>
							<td style="border-bottom: 1px dashed black; line-height: 5px;">
								E-Mail: <span>'.$user_details['email'].'</span>
							</td>
						</tr>
						<tr>
							<td style="border-bottom: 1px dashed black; line-height: 5px;">
								Phone Number: <span>'.$user_details['phone'].'</span>
							</td>
						</tr>
						<tr>
							<td style="border-bottom: 1px dashed black; line-height: 5px;">
								Presented to:
							</td>
						</tr>
						<tr>
							<td style="border-bottom: 1px dashed black; line-height: 5px;">
								&nbsp;
							</td>
						</tr>
						<tr>
							<td style="border-bottom: 1px dashed black; line-height: 5px;">
								&nbsp;
							</td>
						</tr>
					</table>
				</td>
				</tr>
				<tr>
					<td>			
					 <table style="font-size: .75em;width: 90%;">
						<tr>
								<td style="padding-right: 0.5cm;">
									P.O. Box 275
									Watamu Kenya
									80202
								</td>
								<td>
									+254 42 233 2420
									<a href="http://www.diveinkenya.com">http://www.diveinkenya.com</a>
								</td>
							</tr>
					 </table>
					</td>
					<td><a href="'.$legal_url.'">'.$legal_url.'</a></td>
				</tr>
			</table>';
		
		return $html;
	}

	public function download_price_list()
	{
		$this->createPriceListPDF();
		//$this->createVoucher();
		exit;
		//var_dump(PDF_HEADER_LOGO);die(PDF_HEADER_LOGO);
				
//		$url = 'http://localhost/reports/prices';
//		
//		if(Kohana::$environment === Kohana::PRODUCTION){
//			$url = URL::base().'reports/prices';
//		}
//		
//		if(isset($_GET['r-currency'])){
//			$url .= '?currency='.$_GET['r-currency'];
//		}
//
//		$file = sys_get_temp_dir().'/aquaventures-rates-'.rand(1, 10000).'.pdf';
//		$wkhtml = APPPATH.'vendor/webkit/wkhtmltopdf-i386';
//		$command = "$wkhtml $url $file --ignore-load-errors";
//		`$command`;
		//$this->download_file($file);
	}
	
	public function download_file($file, $fileName = 'Aqua Ventures Rates.pdf', $delete = TRUE)
	{
        $this->response->send_file($file, $fileName, array('delete' => $delete));
	}
	
		
	function set_rate($curr){
		$price_currency = Kohana::$config->load('currency.price_currency');
		$currency_controller = new Kohana_Controller_Currency($this->request, $this->response);
	
		if($curr != $price_currency){
			$curr = $currency_controller->convert($curr, $price_currency);
			$this->rate = $curr['rate'];
		}
	}
	
	function convert_prices($prices){
		foreach ($prices as $key => $value)
		{
			$prices[$key] = array($value,$this->convert_value($value));
		}
		return $prices;
	}
	
	function convert_value($value){
		$value = $value / $this->rate;
		return number_format($value, 2, '.', '');
	}
	
}
