<?php defined('SYSPATH') or die('No direct script access.');

class Controller_Sitemap extends Controller {

	public function action_index()
	{
		
		$this->response->headers('Content-Type', 'text/xml');
		$view = Kostache::factory('sitemap');
		
		$view->base_url = Kohana::$base_url;
		
		$view->blog_urls = $this->get_blog_urls();
		$view->gallery_urls = $this->get_gallery_urls();
		
		$this->response->body($view);
	}
	
	
	protected function get_blog_urls()
	{
		$blog_urls = array();
		
		$data = Node::factory('blogpost', NULL, array('author', 'date', 'code'))
					->published()
					->order_by_option('date', 'DESC')
					->find_all();
		
		foreach ($data as $row)
		{
			$blog_urls[] = $row->option('code');
		}
		
		return $blog_urls;
	}
	
	public function get_gallery_urls()
	{
		$gallery_urls = array();
		
		$data = Node::factory('gallery', NULL, array('date'))
					->order_by_option('date', 'DESC')
					->published()
					->find_all();
		foreach ($data as $row)
		{
			$gallery = $row->gallery;
			$gallery_urls[] = ($gallery->type === 'Y' ? 'video' : 'photo' ) . ':' . $gallery->code;
		}
		return $gallery_urls;
	}
}
