<?php defined('SYSPATH') or die('No direct script access.');
/**
 * Menu
 */
class Menu {

	public static function factory($controller, $identifier=NULL)
	{
		return new Menu($controller, $identifier);
	}
	
	private $controller, $menu, $current;

	private function __construct($controller, $identifier)
	{
		$this->controller = $controller;
		$this->identifier = $identifier;
		$this->prepare();
	}
	
	private function prepare()
	{
		$directory = Arr::get(Request::initial()->route()->defaults(), 'directory');
		$this->current = '/'.preg_replace('#^'.$directory.'#', '', Request::initial()->uri());
		
		$items = $this->controller->menu_data($this->identifier);
		
		$menu = array();
		
		foreach ($items as $item)
		{
			$item = $this->controller->menu_item($item, $this->identifier);
			$menu[] = $this->active($item);
		}
		
		$this->menu = $menu;
	}
	
	private function active($item)
	{
		$is_active = $this->controller->is_active($item, $this->current, $this->identifier);
		$item['class'] = $is_active ? $item['class'].' active' : $item['class'];
		return $item;
	}
	
	public function items()
	{
		return $this->menu;
	}
	
}
