<?php defined('SYSPATH') or die('No direct script access.');

class View_Page_Admin_Blog_Index extends Abstract_View_Page {

	public $title = 'Blog';
	
	protected $_layout = 'layout/administrator';

	protected $assets_group = "blog";
	
	public $_partials = array(
			'edit' => 'partial/admin/blog/edit',
	);
	
	public $statuses = array(
			'published', 'hidden', 'rejected', 'draft', 'deleted',
	);
	
	public $is_blog_editor = TRUE;
	
	public function assets($assets)
	{
		$assets->group('administrator');
		return parent::assets($assets);
	}
	
	public function statuses()
	{
		$list = array();
		foreach ($this->statuses as $status)
		{	
			if(isset($this->selected) && $status === $this->selected)
			{
				$list[] = array(
						'value' => $status,
						'selected' => 'selected',
				);
			}else
			{
				$list[] = array('value' => $status);
			}
		}
		return $list;
	}
	
	
	public function render($template = null, $view = null, $partials = null)
	{	
		if(!isset($this->id))
		{
			$this->_partials = array();
		}
		$content = parent::render();
		return $content;
	}
}