<?php defined('SYSPATH') or die('No direct script access.');

class Login_View_Page_User_Register extends Abstract_View_Page {

	public $username, $email;

	public $errors = array();

	public function has_errors()
	{
		return (bool) $this->errors();
	}

	public function errors()
	{
		$errors = array();
		foreach ($this->errors as $key => $error)
		{
			$errors[] = array('key' => $key, 'error' => $error);
		}

		return $errors;
	}

	public function username()
	{
		return array(
			'name' => 'username',
			'value' => $this->username,
			'id' => 'username',
			'label' => Kohana::message('user', 'username.label'),
			'has_error' => Arr::get($this->errors, 'username'),
			'error' => Arr::get($this->errors, 'username'),
		);
	}

	public function email()
	{
		return array(
			'name' => 'email',
			'value' => $this->email,
			'id' => 'email',
			'label' => Kohana::message('user', 'email.label'),
			'has_error' => Arr::get($this->errors, 'email'),
			'error' => Arr::get($this->errors, 'email'),
		);
	}

	public function password()
	{
		return array(
			'name' => 'password',
			'id' => 'password',
			'label' => Kohana::message('user', 'password.label'),
			'has_error' => Arr::get($this->errors, 'password'),
			'error' => Arr::get($this->errors, 'password'),
		);
	}

	public function confirm()
	{
		return array(
			'name' => 'confirm',
			'id' => 'confirm',
			'label' => Kohana::message('user', 'confirm.label'),
			'has_error' => Arr::get($this->errors, 'confirm'),
			'error' => Arr::get($this->errors, 'confirm'),
		);
	}

}
